#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_StarLotteryRateCFG.h"
std::auto_ptr<M_StarLotteryRateCFG> M_StarLotteryRateCFG::msSingleton(nullptr);

int M_StarLotteryRateCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_StarLotteryRateCFGData* M_StarLotteryRateCFG::GetData(int UpRange)
{
	auto it = mMapData.find(UpRange);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_StarLotteryRateCFGData>& M_StarLotteryRateCFG::GetMapData()
{
	return mMapData;
}

void M_StarLotteryRateCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_StarLotteryRateCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_StarLotteryRateCFGData data;
		data.mUpRange = element->IntAttribute("UpRange");
		data.mDailyRate = element->IntAttribute("DailyRate");
		data.mTotalRate = element->IntAttribute("TotalRate");
		if (mMapData.find(data.mUpRange) != mMapData.end())std::cout <<"data refind:" << data.mUpRange << std::endl;
		CCASSERT(mMapData.find(data.mUpRange) == mMapData.end(), "data.mUpRange is exists");
		mMapData.insert(std::make_pair(data.mUpRange, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_StarLotteryRateCFG Loaded. Load Data:%u", mMapData.size());
}

void M_StarLotteryRateCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_StarLotteryRateCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_StarLotteryRateCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_StarLotteryRateCFGData data;
		LuaCfgHelper::readInt(L, "UpRange", data.mUpRange);
		LuaCfgHelper::readInt(L, "DailyRate", data.mDailyRate);
		LuaCfgHelper::readInt(L, "TotalRate", data.mTotalRate);
		if (mMapData.find(data.mUpRange) != mMapData.end())std::cout <<"data refind:" << data.mUpRange << std::endl;
		CCASSERT(mMapData.find(data.mUpRange) == mMapData.end(), "data.mUpRange is exists");
		mMapData.insert(std::make_pair(data.mUpRange, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_StarLotteryRateCFG Loaded. Load Data:%u", mMapData.size());
}

void M_StarLotteryRateCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_StarLotteryRateCFG* M_StarLotteryRateCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_StarLotteryRateCFG());
	}
	return msSingleton.get();
}

void M_StarLotteryRateCFG::Release()
{
	msSingleton.reset(nullptr);
}
